org.deidentifier.arx.criteria

## Class RecursiveCLDiversity

- java.lang.Object
- - org.deidentifier.arx.criteria.PrivacyCriterion
  - - org.deidentifier.arx.criteria.ExplicitPrivacyCriterion
    - - org.deidentifier.arx.criteria.LDiversity
      - - org.deidentifier.arx.criteria.RecursiveCLDiversity

All Implemented Interfaces:
  java.io.Serializable

    public class RecursiveCLDiversity
    extends LDiversity

The recursive-(c,l)-diversity criterion.

Author:
  Fabian Prasser, Florian Kohlmayer
See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`RecursiveCLDiversity(java.lang.String attribute, double c, int l)` Creates a new instance of the recursive-(c,l)-diversity criterion as proposed in: Machanavajjhala A, Kifer D, Gehrke J.

### Method Summary

All Methods Instance Methods Concrete Methods
`RecursiveCLDiversity` `clone()` Clone
`double` `getC()` Returns the parameter c.
`boolean` `isAnonymous(Transformation<?> node, HashGroupifyEntry entry)` Implement this, to enforce the criterion.
`boolean` `isLocalRecodingSupported()` Returns whether the criterion supports local recoding.
`ElementData` `render()` Renders the privacy model
`java.lang.String` `toString()` Returns a string representation.

### Methods inherited from class org.deidentifier.arx.criteria.LDiversity

`getL, getMinimalClassSize, getRequirements, getRiskThresholdJournalist, getRiskThresholdMarketer, getRiskThresholdProsecutor, isMinimalClassSizeAvailable`

### Methods inherited from class org.deidentifier.arx.criteria.ExplicitPrivacyCriterion

`getAttribute, initialize`

### Methods inherited from class org.deidentifier.arx.criteria.PrivacyCriterion

`clone, getDataSubset, getPopulationModel, getSubset, isHeuristicSearchSupported, isHeuristicSearchWithTimeLimitSupported, isMonotonicWithGeneralization, isMonotonicWithSuppression, isOptimalSearchSupported, isSampleBased, isSubsetAvailable`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### RecursiveCLDiversity

    public RecursiveCLDiversity(java.lang.String attribute,
                                double c,
                                int l)

Creates a new instance of the recursive-(c,l)-diversity criterion as proposed in: Machanavajjhala A, Kifer D, Gehrke J. l-diversity: Privacy beyond k-anonymity. Transactions on Knowledge Discovery from Data (TKDD). 2007;1(1):3.

Parameters:
  `attribute` -
  `c` -
  `l` -

### Method Detail

#### clone

    public RecursiveCLDiversity clone()

Description copied from class: `PrivacyCriterion`
Clone

Specified by:
  `clone` in class `PrivacyCriterion`

#### getC

    public double getC()

Returns the parameter c.

Returns:

#### isAnonymous

    public boolean isAnonymous(Transformation<?> node,
                               HashGroupifyEntry entry)

Description copied from class: `PrivacyCriterion`
Implement this, to enforce the criterion.

Specified by:
  `isAnonymous` in class `PrivacyCriterion`
Parameters:
  `node` - TODO
Returns:

#### isLocalRecodingSupported

    public boolean isLocalRecodingSupported()

Description copied from class: `PrivacyCriterion`
Returns whether the criterion supports local recoding.

Specified by:
  `isLocalRecodingSupported` in class `PrivacyCriterion`
Returns:

#### render

    public ElementData render()

Description copied from class: `PrivacyCriterion`
Renders the privacy model

Specified by:
  `render` in class `PrivacyCriterion`
Returns:

#### toString

    public java.lang.String toString()

Description copied from class: `PrivacyCriterion`
Returns a string representation.

Specified by:
  `toString` in class `PrivacyCriterion`